/*
 *		Test of rexxflow.library
 */

DT_DELETE = 208
DT_TRUNCATE = 176

call addlib("rexxflow.library", 0, -30, 0)

call SetOutbound("work:welmat/rexxflow")

myaddress.domain = "Fidonet"
myaddress.zone = 1
myaddress.net = 163
myaddress.node = 206
myaddress.point = 8

/* wrt above, I want my nightly poll to occur uneventfully :-) */

call SetDefaultAddress(myaddress)

work_detail = FindDetail(myaddress)
say work_detail

say AddWork(work_detail, "alpha", DT_TRUNCATE)
say AddWork(work_detail, "beta", DT_DELETE)

call DumpOutbound("")

call ScanDetail(work_detail, huge_list)

do i = 1 until i = huge_list.numnodes
	say huge_list.i.filename
	say huge_list.i.asname
	say huge_list.i.flags
	say " "
	end

call remlib("rexxflow.library")

